﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Net;
using System.Net.Sockets;
using System.IO;

namespace 套节字server_and_client
{
    public partial class 服务器端 : Form
    {
        public 服务器端()
        {
            InitializeComponent();
            TextBox.CheckForIllegalCrossThreadCalls = false;
        }
      
        Socket socketWith;
        Dictionary<string, Socket> dicSoc = new Dictionary<string, Socket>();
        private void btnStart_Click(object sender, EventArgs e)
        {
             socketWith = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPAddress IP = IPAddress.Parse(txtIP.Text);
            IPEndPoint point = new IPEndPoint(IP, int.Parse(txtPoint.Text));
            socketWith.Bind(point);
            socketWith.Listen(10);
            displayMes("服务已启动！");
           Thread  acceptThread = new Thread(accept);
            acceptThread.IsBackground = true;
            acceptThread.Start();
            
    
        }
        
        private void accept()
        {
            while (true)
            {
                Socket createSocket = socketWith.Accept();
                dicSoc.Add(createSocket.RemoteEndPoint.ToString(), createSocket);
                libRemote.Items.Add(createSocket.RemoteEndPoint.ToString());
                Thread sendThread = new Thread(send);
                sendThread.IsBackground = true;
                sendThread.Start(createSocket);

                displayMes("已连接成功！");               
            }
        
        }
        private void send(object  obj )
        {
            Socket soc = (Socket)obj;
            while (true)
            {
                byte[] send = new byte[1024 * 1024 * 2];
                int length = soc.Receive(send);
                if (send[0] == 0)
                {
                    string str = Encoding.Default.GetString(send, 1, length);
                    displayMes(soc.RemoteEndPoint.ToString() + "发来的信息：" + "r\n" + str);
                }
                else {
                    SaveFileDialog sfd = new SaveFileDialog();
                    if (sfd.ShowDialog() != DialogResult.OK)
                    {
                        return;
                    }
                    using (FileStream file=new FileStream(sfd.FileName,FileMode.Create))
                    {
                        file.Write(send, 1, length);
                        displayMes("文件保存成功");
                    }
                
                }
            }
        }
        public void displayMes(string str)
        {
            txtMes.AppendText(str + "\r\n");
        }

        private void butSend_Click(object sender, EventArgs e)
        {
            byte[] send = new byte[1024 * 1024 * 2];
            send = Encoding.Default.GetBytes(txtMeSend.Text);
           object obj = libRemote.SelectedItem;
            if (obj == null)
            {
                libRemote.SelectedIndex = 0;
                    obj = libRemote.SelectedItem;                
            }
            string str = obj.ToString();
            dicSoc[str].Send(send);
            displayMes(string.Format("向{0}发送的信息为：\r\n {1}",str,txtMeSend.Text) );
            txtMeSend.Text = "";
        }

        private void btnAllSend_Click(object sender, EventArgs e)
        {
            byte[] send = new byte[1024 * 1024 * 2];
            send = Encoding.Default.GetBytes(txtMeSend.Text);
            foreach (string str in dicSoc.Keys)
            {
                dicSoc[str].Send(send);
            }
            displayMes("群发已完成，内容为： \r\n " + txtMeSend.Text);
            txtMeSend.Text = "";
        }

    }
}
